<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin: 0 0 5px 0;
		}

		h2 {
			font-size: 13px;
			font-weight: bold;
			margin: 5px 0 5px 0;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
			text-align: left;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Database Caching</h1>

		<p>The database class allows you to cache your queries as text files for reducing the database load.</p>

		<p>The caching class is loaded automatically loaded by the database class you do not have to manually load
		it.</p>
	</div>

	<div class="content">
		<h1>Enabling Caching</h1>

		<p>Caching is enabled by following these three steps.</p>

		<ul>
			<li>Create a directory on the server where the cache files will be stored.</li>
			<li>Set the path to your cache directory in your <b>application/config/database.php</b> file.</li>
			<li>Enabled the caching feature, either globally in the configuration settings or manually as described
			below.</li>
		</ul>

		<p>Once caching is enabled caching will happen automatically whenever a page is loaded that contains any
		database queries.</p>
	</div>

	<div class="content">
		<h1>How Does Caching Work</h1>

		<p>CarbonPHP caching happens dynamically when your pages are viewed.  When caching is enabled the first time
		a page is loaded the query result object will be serialised and stored in a text file on the server. The next
		time the page is loaded the cache file will be served instead of accessing the database.</p>

		<p>Only 'read' type queries can be cached, since these are the only type of queries that produce a result
		object.</p>

		<p>Cache files do not expire.  Any queries that have been called will remain cached until you delete them.
		The caching system permits you to clear caches associated with individual pages, or you can delete the
		whole set of cache files.</p>
	</div>

	<div class="content">
		<h1>Does Caching Improve Site Performance</h1>

		<p>Getting a performance gain as a result of caching depends on many factors.  If you have a highly optimised
		database under very little load you will probably not noticed an improved performance.  If your database
		is under heavy load you probably will see an improved response.</p>

		<p>In some clustered server environments for example caching may be detrimental since file system operations
		are so instense.  On single servers in shared environments caching you probably be more benficial.</p>
	</div>

	<div class="content">
		<h1>How are Cache Files Stored</h1>

		<p>CarbonPHP places the result of each query into it's own cache file which are then organised into
		subdirectories corresponding to the name of your controller and method.</p>

		<p>For example if you have a controller called <b>blog</b> and a method called <b>post</b> that contains
		three queries, the caching system will create a cache directory called <b>blog+post</b> into which it
		will create three cache files, one for each query.</p>
	</div>

	<div class="content">
		<h1>Managing Cache Files</h1>

		<p>Since cache files do not expire you will need to use the built in deletion methods to remove old cache
		files.</p>
	</div>

	<div class="content">
		<h1>Unsupported Methods</h1>

		<p>Some methods are not supported by the caching system.</p>

		<ul>
			<li>num_fields()</li>
			<li>field_names()</li>
			<li>field_data()</li>
			<li>free_result()</li>
		</ul>

		<p>The database connection ID and result ID are not available when caching.</p>
	</div>

	<div class="content">
		<h1>$this->db->cache_on() and $this->db->cache_off()</h1>

		<p>This method enables and disabled the caching manually.  This can be useful if you wish to keep certain
		queries from being cached.</p>

		<div class="example">
			$this->db->cache_on();<br />
			$query = $this->db->query('SELECT * FROM `some_table`');<br />
			<br />
			$this->db->cache_off();<br />
			$query = $this->db->query('SELECT * FROM `another_table`');<br />
			<br />
			$this->db->cache_on();<br />
			$query = $this->db->query('SELECT * FROM `more_table`');
		</div>
	</div>

	<div class="content">
		<h1>$this->db->cache_delete()</h1>

		<p>This method deletes the cache files associated with a particular page.  This is useful if you need to clear
		a cache file after you update your database.</p>

		<p>The caching system saves your cache files to directories correspond to the URI of the page you are viewing.
		To delete the cache files of a controller and method you should the following.</p>

		<div class="example">
			$this->db->cache_delete('blog', 'posts');
		</div>

		<p>If you do not pass any parameters to the function it will determine the cache files based on the current
		URL.</p>
	</div>

	<div class="content">
		<h1>$this->db->cache_delete_all()</h1>

		<p>Clears all the existing cache files.</p>

		<div class="example">
			$this->db->cache_delete_all();
		</div>
	</div>
</body>

</html>
